<template>
  <div>
    <div class="menu-container">
      <!-- 當 :activeIndex 等於 :index 的值時, menu 的該 tab就會自動設為 active -->
      <el-menu router :default-active="activeIndex" mode="horizontal" @select="menuSelect">
        <template v-if="leafRouters.length > 1">
          <el-menu-item
            v-for="router in leafRouters"
            :key="router.path"
            :index="router.name"
          >{{ router.meta.title }}</el-menu-item>
        </template>
        <template v-else>
          <div class="menu-margin" />
        </template>
      </el-menu>
    </div>
    <!-- 用 Button 的範例
    <br >
    <div class="menu-container">
      <el-button-group>
        <el-button
          v-for="router in leafRouters"
          :key="router.path"
          type="primary"
          @click.native="$router.push({ path: router.name })"
        >{{ router.meta.title }}</el-button>
      </el-button-group>
    </div>-->
    <div class="app-container">
      <router-view />
    </div>
  </div>
</template>

<script>
import { setAction, clearAction, clearRowData } from '@/utils/common'

export default {
  data() {
    return {
      activeIndex: this.$route.matched[2].name
    }
  },
  computed: {
    leafRouters() {
      // 找出第3層的功能清單(router), 例: route = /basic/bonus/
      let leafRoutes = null
      const routers = this.$router.options.routes // 第一層所有的 route
      const rootPath = this.$route.matched[0].path // 第一層 route 的路徑, 例 /basic

      routers.some(route => {
        // 找第二層的 route
        if (route.path === rootPath) {
          const subRouters = route.children // 第二層所有的 route

          const result = subRouters.some(subRoute => {
            const subPath = this.$route.matched[1].path.split('/')[2] // 第二層 route 的路徑, 例 bonus

            // console.log(`subRoute.path = ${subRoute.path}`)
            // console.log(`subPath = ${subPath}`)

            // 找第三層的 route
            if (subRoute.path === subPath) {
              // console.log(subRoute.children)
              leafRoutes = subRoute.children
              return true
            }
          })

          if (result) return true
        }
      })

      // console.log(leafRoutes.length)
      return leafRoutes
    }
  },
  methods: {
    menuSelect(index, indexPath) {
      // 選擇新增時 action= add, 其它則刪除 action
      if (index.endsWith('/add')) {
        setAction('add')
        clearRowData()
      } else {
        clearAction()
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.menu-container {
  padding: 0px 20px 0px 20px;
}

.el-menu.el-menu--horizontal {
  border-bottom: none;
}

.menu-margin {
  margin-top: 18px;
}
</style>

